VERSION 5.00
Begin VB.UserControl TrayIcon 
   ClientHeight    =   270
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   240
   RightToLeft     =   -1  'True
   ScaleHeight     =   270
   ScaleWidth      =   240
   Begin VB.Image Image1 
      Height          =   240
      Left            =   0
      Picture         =   "TrayIcon.ctx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   240
   End
End
Attribute VB_Name = "TrayIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'   ________________________
'   ========================
'   ////////mousavi/////////
'   ########################

Private Const APP_SYSTRAY_ID = 999 'unique identifier
Private Const NOTIFYICON_VERSION = &H3
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const NIF_STATE = &H8
Private Const NIF_INFO = &H10
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIM_SETFOCUS = &H3
Private Const NIM_SETVERSION = &H4
Private Const NIM_VERSION = &H5
Private Const NIS_HIDDEN = &H1
Private Const NIS_SHAREDICON = &H2
'icon flags
Private Const NIIF_NONE = &H0
Private Const NIIF_INFO = &H1
Private Const NIIF_WARNING = &H2
Private Const NIIF_ERROR = &H3
Private Const NIIF_GUID = &H5
Private Const NIIF_ICON_MASK = &HF
Private Const NIIF_NOSOUND = &H10
Private Const WM_USER = &H400
Private Const NIN_BALLOONSHOW = (WM_USER + 2)
Private Const NIN_BALLOONHIDE = (WM_USER + 3)
Private Const NIN_BALLOONTIMEOUT = (WM_USER + 4)
Private Const NIN_BALLOONUSERCLICK = (WM_USER + 5)
'Event const
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDBLCLK = &H203
Private Const WM_LBUTTONDOWN = &H201
Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONDBLCLK = &H206
Private Const WM_RBUTTONDOWN = &H204
Private Const WM_RBUTTONUP = &H205
Private Const WM_MOUSEOVER = &H200
'shell version / NOTIFIYICONDATA struct size constants
Private Const NOTIFYICONDATA_V1_SIZE As Long = 88  'pre-5.0 structure size
Private Const NOTIFYICONDATA_V2_SIZE As Long = 488 'pre-6.0 structure size
Private Const NOTIFYICONDATA_V3_SIZE As Long = 504 '6.0+ structure size
Private NOTIFYICONDATA_SIZE As Long
Private Type GUID
   Data1 As Long
   Data2 As Integer
   Data3 As Integer
   Data4(7) As Byte
End Type
Private Type NOTIFYICONDATA
  cbSize As Long
  hWnd As Long
  uID As Long
  uFlags As Long
  uCallbackMessage As Long
  hIcon As Long
  szTip As String * 128
  dwState As Long
  dwStateMask As Long
  szInfo As String * 256
  uTimeoutAndVersion As Long
  szInfoTitle As String * 64
  dwInfoFlags As Long
  guidItem As GUID
End Type
Public Enum TipIcon
        None = 0
        Information = 1
        Warning = 2
        Error = 3
End Enum
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Private Declare Function GetFileVersionInfoSize Lib "version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Private Declare Function GetFileVersionInfo Lib "version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwHandle As Long, ByVal dwLen As Long, lpData As Any) As Long
Private Declare Function VerQueryValue Lib "version.dll" Alias "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, lpBuffer As Any, nVerSize As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Event MouseMove()
Event MouseDown(Button As Integer)
Event MouseUp(Button As Integer)
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick


Dim ico As Picture, trayl As Boolean, Balooni As TipIcon
Dim Tooltipl, Baloonti, Baloont As String
Dim nid As NOTIFYICONDATA

Private Sub ShellTrayAdd()
   
'   Dim nid As NOTIFYICONDATA
   
   If NOTIFYICONDATA_SIZE = 0 Then SetShellVersion
   
  'set up the type members
   With nid
   
      .cbSize = NOTIFYICONDATA_SIZE
      .hWnd = UserControl.hWnd
      .uID = APP_SYSTRAY_ID
      .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
      .dwState = NIS_SHAREDICON
      .hIcon = Image1.Picture
      .uCallbackMessage = WM_MOUSEMOVE
      'szTip is the tooltip shown when the
      'mouse hovers over the systray icon.
      'Terminate it since the strings are
      'fixed-length in NOTIFYICONDATA.
      .szTip = Tooltipl & vbNullChar
      .uTimeoutAndVersion = NOTIFYICON_VERSION
      
   End With
   
  'add the icon ...
   Call Shell_NotifyIcon(NIM_ADD, nid)
   
  '... and inform the system of the
  'NOTIFYICON version in use
   Call Shell_NotifyIcon(NIM_SETVERSION, nid)
       
End Sub
Private Sub ShellTrayRemove()

'   Dim nid As NOTIFYICONDATA
   
   If NOTIFYICONDATA_SIZE = 0 Then SetShellVersion
      
   With nid
      .cbSize = NOTIFYICONDATA_SIZE
      .hWnd = UserControl.hWnd
      .uID = APP_SYSTRAY_ID
   End With
   
   Call Shell_NotifyIcon(NIM_DELETE, nid)

End Sub
Private Sub ShellTrayModifyTip(nIconIndex As Long)

   
   If NOTIFYICONDATA_SIZE = 0 Then SetShellVersion
   
   With nid
      .cbSize = NOTIFYICONDATA_SIZE
      .hWnd = UserControl.hWnd
      .uID = APP_SYSTRAY_ID
      .uFlags = NIF_INFO
      .dwInfoFlags = nIconIndex
      
      'InfoTitle is the balloon tip title,
      'and szInfo is the message displayed.
      'Terminating both with vbNullChar prevents
      'the display of the unused padding in the
      'strings defined as fixed-length in NOTIFYICONDATA.
      .szInfoTitle = Baloonti & vbNullChar
      .szInfo = Baloont & vbNullChar
   End With

   Call Shell_NotifyIcon(NIM_MODIFY, nid)

End Sub
Private Sub SetShellVersion()

   Select Case True
      Case IsShellVersion(6)
         NOTIFYICONDATA_SIZE = NOTIFYICONDATA_V3_SIZE '6.0+ structure size
      
      Case IsShellVersion(5)
         NOTIFYICONDATA_SIZE = NOTIFYICONDATA_V2_SIZE 'pre-6.0 structure size
      
      Case Else
         NOTIFYICONDATA_SIZE = NOTIFYICONDATA_V1_SIZE 'pre-5.0 structure size
   End Select

End Sub
Private Function IsShellVersion(ByVal version As Long) As Boolean

  'returns True if the Shell version
  '(shell32.dll) is equal or later than
  'the value passed as 'version'
   Dim nBufferSize As Long
   Dim nUnused As Long
   Dim lpBuffer As Long
   Dim nVerMajor As Integer
   Dim bBuffer() As Byte
   
   Const sDLLFile As String = "shell32.dll"
   
   nBufferSize = GetFileVersionInfoSize(sDLLFile, nUnused)
   
   If nBufferSize > 0 Then
    
      ReDim bBuffer(nBufferSize - 1) As Byte
    
      Call GetFileVersionInfo(sDLLFile, 0&, nBufferSize, bBuffer(0))
    
      If VerQueryValue(bBuffer(0), "\", lpBuffer, nUnused) = 1 Then
         
         CopyMemory nVerMajor, ByVal lpBuffer + 10, 2
        
         IsShellVersion = nVerMajor >= version
      
      End If  'VerQueryValue
    
   End If  'nBufferSize
  
End Function

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 Select Case X / Screen.TwipsPerPixelX
    Case WM_LBUTTONDBLCLK
        RaiseEvent DblClick
    Case WM_LBUTTONDOWN
        RaiseEvent MouseDown(vbLeftButton)
    Case WM_LBUTTONUP
        RaiseEvent MouseUp(vbLeftButton)
    Case WM_RBUTTONDBLCLK
        RaiseEvent DblClick
    Case WM_RBUTTONDOWN
        RaiseEvent MouseDown(vbRightButton)
    Case WM_RBUTTONUP
        RaiseEvent MouseUp(vbRightButton)
    Case WM_MOUSEOVER
        RaiseEvent MouseMove
    End Select
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
'Image1.Picture = PropBag.ReadProperty("icon", Image1.Picture)
Tooltipl = PropBag.ReadProperty("tooltip", "Tool Tip")
Baloonti = PropBag.ReadProperty("baloontitle", "Title")
Baloont = PropBag.ReadProperty("baloontext", "Text for information")
Balooni = PropBag.ReadProperty("baloonicon", 0)
End Sub

Private Sub UserControl_Resize()
UserControl.Width = 240
UserControl.Height = 240
End Sub

Private Sub UserControl_Terminate()
   ShellTrayRemove
End Sub
Public Property Get Tray() As Boolean
Tray = trayl
End Property
Public Property Let Tray(ByVal New_Tray As Boolean)
If New_Tray = True Then
   ShellTrayAdd
Else
  ShellTrayRemove
End If
trayl = New_Tray
End Property
Public Property Get Icon() As Picture
Set Icon = Image1.Picture
End Property
Public Property Set Icon(ByVal New_Icon As Picture)
Set Image1.Picture = New_Icon
If Me.Tray = True Then
'ShellTrayRemove
nid.uFlags = NIF_ICON
nid.hIcon = Image1.Picture
Shell_NotifyIcon NIM_MODIFY, nid
End If
UserControl.PropertyChanged "icon"
End Property

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
PropBag.WriteProperty "icon", Image1.Picture, UserControl.Image
PropBag.WriteProperty "tooltip", Tooltipl, "Tool Tip"
PropBag.WriteProperty "baloontitle", Baloonti, "Title"
PropBag.WriteProperty "baloontext", Baloont, "Text for information"
PropBag.WriteProperty "baloonicon", Balooni, 0
End Sub
Public Property Get Tooltip() As String
Tooltip = Tooltipl
End Property
Public Property Let Tooltip(ByVal New_Tooltip As String)
 Tooltipl = New_Tooltip
UserControl.PropertyChanged "tooltip"
End Property

Public Property Get BaloonTitle() As String
BaloonTitle = Baloonti
End Property
Public Property Let BaloonTitle(ByVal New_BaloonTitle As String)
 Baloonti = New_BaloonTitle
UserControl.PropertyChanged "baloontitle"
End Property
Public Property Get BaloonText() As String
BaloonText = Baloont
End Property
Public Property Let BaloonText(ByVal New_BaloonText As String)
 Baloont = New_BaloonText
UserControl.PropertyChanged "baloontext"
End Property

Public Property Get BaloonIcon() As TipIcon
BaloonIcon = Balooni
End Property
Public Property Let BaloonIcon(ByVal New_BaloonIcon As TipIcon)
 Balooni = New_BaloonIcon
UserControl.PropertyChanged ("baloonicon")
End Property

Public Function Showtip()
If Me.Tray = True Then
ShellTrayModifyTip True * (-(Me.BaloonIcon))
End If
End Function
